<template>
  <v-card class="elevation-12">
      <Loading :visible="isLoading" />
      <v-form>
          <v-card-title>Veuillez entrer votre email</v-card-title>
          <v-card-text>
            <v-text-field  
              v-model="email" 
              type="email"
              placeholder="Email"
              id="email"
              autocomplete="username"
              :error-messages="emailErrors"
            />
          </v-card-text>
          <v-card-actions>
            <v-btn color="secondary" light type="submit" @click="sendEmail">
              Envoyer
            </v-btn>

          </v-card-actions>
      </v-form>
  </v-card>
</template>


<script>
import { mapActions } from 'vuex';
import {
  mapFields
} from 'vuex-map-fields';
import {
  email,
  required
} from 'vuelidate/lib/validators';
import NotificationMixin from '../../mixins/NotificationMixin';
import Loading from '../../components/Loading';

export default {
  name: 'EmailInputPassword',
  mixins: [NotificationMixin],
  components:{
    Loading
  },
  validations: {
    email: { required, email }
  },
  props: {
    token:String
  },
  data: () => ({
    email:'',
    errors: []
  }),
  computed: {
		emailErrors () {
			const errors = []
			if (!this.$v.email.$dirty) return errors
			!this.$v.email.email && errors.push('Email non valide')
			!this.$v.email.required && errors.push('Email requis')
			return errors
		},
    ...mapFields('user', ['emailSent','error', 'isLoading']),
  },
  created() {
    this.resetSentEmail();
  },
  methods: {
    sendEmail: function() {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      this.sendEmailForgetPassword(this.email);

    },
    ...mapActions('user', ['sendEmailForgetPassword', 'resetSentEmail'])
  },
  watch: {
    emailSent(newData) {
      if (newData) {
        this.$router.push({name : 'login'});
        this.showMessage('Un mail a été envoyé à l\'adresse email indiquée' , 'success');   
      }
    },
    error(newError) {
      if(newError && newError['404'] ) {
        this.showMessage('Email non valide' , 'error');   
      }
    }
  }
}
</script>
